module.exports = function(grunt) {

    // Project configuration.
    grunt.initConfig({
        concat: {
            all: {
                src: ['src/**/*.js', 'Main.js'],
                dest:  '../app/all.js',
                nonull: true
            },
            tests: {
                src: ['src/**/*.js', 'test/**/*.js'],
                dest: 'all_tests.js',
                nonull:  true
            },
        },

        pkg: grunt.file.readJSON('package.json'),

        uglify: {
            options: {
                banner: '/*! <%= pkg.name %> <%= grunt.template.today("yyyy-mm-dd") %> */\n',
                mangle: false
            },
            app: {
                files: {
                  '../app/lib.min.js': ['src/**/*.js', 'Main.js']
                }
            }
        }
    });

    grunt.loadNpmTasks('grunt-contrib-concat');
    grunt.loadNpmTasks('grunt-contrib-uglify');

    // Default task(s).
    grunt.registerTask('default', ['concat', 'uglify']);
};
